﻿// © Benn Eichhorn 2010
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Algobox.Feeds.Finance.Chix.CHIXMD.Messages
{
    /// <summary>
    /// Singleton Heartbeat
    /// </summary>
    public class Heartbeat : IMessage
    {
        private Heartbeat() { }

        private static Heartbeat m_instance = new Heartbeat();

        /// <summary>
        /// Get's the singleton instance of the Heartbeat class
        /// </summary>
        /// <returns>Current Heartbeat</returns>
        public static Heartbeat GetInstance() { return m_instance; }

        public char MessageType { get { return 'H'; } }

        public override string ToString()
        {
            return "IMessage->Heartbeat";
        }
    }
}
