﻿// © Benn Eichhorn 2010
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Algobox.Feeds.Finance.Chix.CHIXMD.Messages
{
    /// <summary>
    /// Chi-X login accepted message
    /// </summary>
    public class LoginAccept : IMessage
    {
        public LoginAccept(string session, int sequence)
        {
            Session = session;
            Sequence = sequence;
        }

        public char MessageType { get { return 'A'; } }

        /// <summary>
        /// The session currently logged into
        /// </summary>
        public string Session { get; set; }

        /// <summary>
        /// The next sequence number you can expect to recieve
        /// </summary>
        public int Sequence { get; set; }

        public override string ToString()
        {
            return String.Format("IMessage->LoginAccept:Session={0},Sequence={1}", Session, Sequence);
        }
    }
}
