﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Algobox.Objects.Finance.Assets.Stock;
using Algobox.Objects.Finance.Prices;
using System.ComponentModel;
using Algobox.Objects.Finance;
using Algobox.Objects.Finance.Depth;

namespace Algobox.Structure.Finance.Prices
{
    public class StockWatch
    {
        public StockWatch(IStock stock)
        {
            Stock = stock;
            Ask = new PriceVolume(PriceVolume.PriceType.Ask);
            Bid = new PriceVolume(PriceVolume.PriceType.Bid);
            Last = new PriceVolume(PriceVolume.PriceType.Last);
            Depth = new Objects.Finance.Depth.Depth(Bid, Ask, Last);
            OHLC = new OHLC();
        }

        public readonly IStock Stock;
        public readonly PriceVolume Bid;
        public readonly PriceVolume Ask;
        public readonly PriceVolume Last;
        public readonly OHLC OHLC;
        public double VWAP;
        public readonly Depth Depth;
        
    }
}
