﻿//
// © Algobox Ltd - Benn Eichhorn
//
using System;
using System.ComponentModel;

namespace Algobox.Structure.Finance.Strategies
{
    public interface IStrategyUnit
    {
        string Name { get; }
        Side Direction { get; }
        double EntryActual { get; }
        double EntryTarget { get; }
        double ExitActual { get; }
        double ExitTarget { get; set; }
        double Profit { get; }
        uint Quantity { get; }
        uint Remaining { get; }
        double SlipEntry { get; }
        double SlipExit { get; }
        Strategy Strategy { get; }
        string TimeStampEntry { get; }
        string TimeStampExit { get; }

        event PropertyChangedEventHandler PropertyChanged;
    }

    public enum Side
    {
        Short,
        Long
    }
}
