﻿//
// © Algobox Ltd - Benn Eichhorn
//
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Algobox.Objects.Finance.Assets.Stock;

namespace Algobox.Structure.Finance.Strategies.SpikeArb
{
    public class SpikeArbStockListing
    {
        #region Constructors

        public SpikeArbStockListing(StockListing listing)
        {
            Listing = listing;
        }


        #endregion
        //////////
        #region Member Variables

        private bool _isEnabled = false;
        public event Action<bool> OnEnabledChanged;

        #endregion
        //////////        
        #region Properties

        public StockListing Listing { get; private set; }
        public bool IsEnabled
        {
            get { return _isEnabled; }
            set
            {
                _isEnabled = value;
                if (OnEnabledChanged != null)
                    OnEnabledChanged(value);
            }
        }

        #endregion


    }
}
